"""Autogenerated file: DO NOT EDIT!"""
import typing  # noqa: F401
from dazzler.system import Component, Aspect, UNDEFINED  # noqa: F401


class Register(Component):
    """
    A user register form.

    :CSS:

        ``dazzler-auth-register``
        - ``register-field``
        - ``register-label``
        - ``register-input``
        - ``register-error``
    """
    _aspect_keys = []
    _children = []
    register_url = Aspect(required=True)
    method = Aspect(default='POST')
    username = Aspect()
    password = Aspect()
    next_url = Aspect()
    username_label = Aspect(default='Username')
    password_label = Aspect(default='Password')
    submit_label = Aspect(default='Register')
    horizontal = Aspect()
    bordered = Aspect()
    placeholder_labels = Aspect()
    extra_fields = Aspect(children=True)
    header = Aspect(children=True)
    footer = Aspect(children=True)
    errors = Aspect()
    class_name = Aspect()
    style = Aspect()

    def __init__(
            self,
            register_url: str,
            method: typing.Optional[str] = 'POST',
            username: typing.Optional[str] = UNDEFINED,
            password: typing.Optional[str] = UNDEFINED,
            next_url: typing.Optional[str] = UNDEFINED,
            username_label: typing.Optional[str] = 'Username',
            password_label: typing.Optional[str] = 'Password',
            submit_label: typing.Optional[str] = 'Register',
            horizontal: typing.Optional[bool] = UNDEFINED,
            bordered: typing.Optional[bool] = UNDEFINED,
            placeholder_labels: typing.Optional[bool] = UNDEFINED,
            extra_fields: typing.Optional[typing.List[typing.Dict[str, typing.Union[str, typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]]]]] = UNDEFINED,  # noqa: E501
            header: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            footer: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            errors: typing.Optional[typing.Dict] = UNDEFINED,
            class_name: typing.Optional[str] = UNDEFINED,
            style: typing.Optional[typing.Dict] = UNDEFINED,
            identity: str = None
    ):
        """
        :param register_url: Url to submit the register form
        :param method: Method to submit the register form. (default='POST')
        :param username: The input username value
        :param password: The input password value
        :param next_url: Redirect to this page after registering.
        :param username_label: The label to show before the.
            (default='Username')
        :param password_label: Label to replace the password.
            (default='Password')
        :param submit_label: Label for the submit button.
            (default='Register')
        :param horizontal: Style the form with the fields side by side.
        :param bordered: Apply a border around the
        :param placeholder_labels: Put the label in placeholder attribute
            instead of a `<label>` element.
        :param extra_fields: Extra fields to include, either provide a
            component or a type for the input.
        :param header: Included as first child of the form. Wrapped under
            div with CSS class ``register-header``
        :param footer: Included at bottom of the register form. Wrapped
            under div with CSS class ``register-footer``
        :param errors: Form errors
        :param class_name:
        :param style:
        """
        Component.__init__(self, locals(), identity)
