"""Autogenerated file: DO NOT EDIT!"""
import typing  # noqa: F401
from dazzler.system import Component, Aspect, UNDEFINED  # noqa: F401


class Image(Component):
    """
    An image.

    :CSS: ``dazzler-core-image``
    """
    _aspect_keys = []
    _children = []
    src = Aspect(required=True)
    alt = Aspect(required=True)
    height = Aspect()
    width = Aspect()
    link = Aspect()
    caption = Aspect(children=True)
    cross_origin = Aspect()
    decoding = Aspect()
    preload = Aspect()
    clicks = Aspect(default=0)
    class_name = Aspect()
    style = Aspect()
    bordered = Aspect()
    rounded = Aspect()
    centered = Aspect()
    flexible = Aspect()
    circle = Aspect()
    padded = Aspect()
    caption_style = Aspect()
    caption_class_name = Aspect()
    figure_class_name = Aspect()
    figure_style = Aspect()
    link_class_name = Aspect()
    link_style = Aspect()

    def __init__(
            self,
            src: str,
            alt: str,
            height: typing.Optional[typing.Union[float, int]] = UNDEFINED,
            width: typing.Optional[typing.Union[float, int]] = UNDEFINED,
            link: typing.Optional[str] = UNDEFINED,
            caption: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            cross_origin: typing.Optional[typing.Any] = UNDEFINED,
            decoding: typing.Optional[typing.Any] = UNDEFINED,
            preload: typing.Optional[bool] = UNDEFINED,
            clicks: typing.Optional[typing.Union[float, int]] = 0,
            class_name: typing.Optional[str] = UNDEFINED,
            style: typing.Optional[typing.Dict] = UNDEFINED,
            bordered: typing.Optional[bool] = UNDEFINED,
            rounded: typing.Optional[bool] = UNDEFINED,
            centered: typing.Optional[bool] = UNDEFINED,
            flexible: typing.Optional[bool] = UNDEFINED,
            circle: typing.Optional[bool] = UNDEFINED,
            padded: typing.Optional[bool] = UNDEFINED,
            caption_style: typing.Optional[typing.Dict] = UNDEFINED,
            caption_class_name: typing.Optional[str] = UNDEFINED,
            figure_class_name: typing.Optional[str] = UNDEFINED,
            figure_style: typing.Optional[typing.Dict] = UNDEFINED,
            link_class_name: typing.Optional[str] = UNDEFINED,
            link_style: typing.Optional[typing.Dict] = UNDEFINED,
            identity: str = None
    ):
        """
        :param src: The source url of the image.
        :param alt: Alt img attribute to show when the browser cannot
            display the image.
        :param height: Height in pixel
        :param width: Width in pixel
        :param link: Link to another page when the image is clicked.
        :param caption: Text to include beneath the image.
        :param cross_origin: Fetch the image with CORS. (Possible values:
            'anonymous', 'use-credentials')
        :param decoding: Decoding hint for the browser (Possible values:
            'sync', 'async', 'auto')
        :param preload: Preload the image before mount.
        :param clicks: Times the image was clicked on. (default=0)
        :param class_name: CSS class to give to root element, (Scoped:
            dazzler-core-image)
        :param style: Style object of the root element.
        :param bordered: Add bordered style class
        :param rounded: Add rounded style class
        :param centered: Add centered style class for the image to appear
            in the horizontal middle
        :param flexible: Take up the whole size of the parent container.
        :param circle: Image is a circle
        :param padded: Add a little padding around the image.
        :param caption_style: Style to give to the caption of the image.
        :param caption_class_name: CSS class to give to the caption of the
            image.
        :param figure_class_name: CSS class to give to figure if caption is
            provided.
        :param figure_style: Style object to give to figure if caption is
            provided.
        :param link_class_name: CSS class to give to the link element.
        :param link_style: Style object to give to the link.
        """
        Component.__init__(self, locals(), identity)
