"""Autogenerated file: DO NOT EDIT!"""
import typing  # noqa: F401
from dazzler.system import Component, Aspect, UNDEFINED  # noqa: F401


class ViewPort(Component):
    """
    Activate a view with key.

    Standalone or tabbed.

    :CSS:

        ``dazzler-core-view-port``
        - ``view-content``
        - ``dazzler-tab``
        - ``dazzler-tabs``
        - ``tab-active``
    """
    _aspect_keys = []
    _children = []
    active = Aspect(required=True)
    views = Aspect(required=True, children=True)
    class_name = Aspect()
    style = Aspect()
    tabbed = Aspect()
    tab_labels = Aspect()
    vertical_tabs = Aspect()
    rounded_tabs = Aspect()
    bordered = Aspect()

    def __init__(
            self,
            active: str,
            views: typing.Dict[str, typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]],  # noqa: E501
            class_name: typing.Optional[str] = UNDEFINED,
            style: typing.Optional[typing.Dict] = UNDEFINED,
            tabbed: typing.Optional[bool] = UNDEFINED,
            tab_labels: typing.Optional[typing.Dict[str, str]] = UNDEFINED,
            vertical_tabs: typing.Optional[bool] = UNDEFINED,
            rounded_tabs: typing.Optional[bool] = UNDEFINED,
            bordered: typing.Optional[bool] = UNDEFINED,
            identity: str = None
    ):
        """
        :param active: The view that is active.
        :param views: A dictionary of components to render with the active
            key.
        :param class_name: The class name of the outer div.
        :param style: Style object of the outer div.
        :param tabbed: Incorporate tabs before the views.
        :param tab_labels: Labels for the tabs otherwise the tab keys will
            be used.
        :param vertical_tabs: Make the tabs vertical aligned.
        :param rounded_tabs: Round tab style
        :param bordered: Add a border around the viewport content (CSS
            bordered).
        """
        Component.__init__(self, locals(), identity)
